'12WK-2313.bas fr Modellbau by Heinz D. ca.1kB
'-------------------------------------------------------------------------------
'Stabilisierung: 16V~ -> 1N4004 -> 1000uF -> +24V= -> 7805 -> +5V= -> 100nF
'-------------------------------------------------------------------------------
' Ampel-Licht     Tasten                                          Signale/Ampel-Licht
' LED                            Tiny2313                               LED
'+24V o-----o 10 +  gnd 9 o  o 1 ---__--- 20 o+5V   ULN2803
'A3gn o-1k2-o 11    T4r 8 o--o 2  PD0 PB7 19 o--o 1 --__-- 18 o-1k2-o S4r/B
'A3ge o-1k2-o 12    T4g 7 o--o 3  PD1 PB6 18 o--o 2        17 o-1k2-o S4g/S
'A3rt o-1k2-o 13    T3r 6 o--o 4  PA1 PB5 17 o--o 3        16 0-1k2-o S3r/A2rt
'A4gn o-1k2-o 14    T3g 5 o--o 5  PA0 PB4 16 o--o 4        15 o-1k2-o S3g/A2ge
'A4ge o-1k2-o 15    T2r 4 o--o 6  PD2 PB3 15 o--o 5        14 o-1k2-o S2r/A2gn
'A4rt o-1k2-o 16    T2g 3 o--o 7  PD3 PB2 14 o--o 6        13 o-1k2-o S2g/A1rt
'  N0 o-1k2-o 17    T1r 2 o--o 8  PD4 PB1 13 o--o 7        12 o-1k2-o S1r/A1ge
'  N1 o-1k2-o 18    T1g 1 o--o 9  PD5 PB0 12 o--o 8        11 o-1k2-o S1g/A1gn
'              -ULN2803-     o 10 gnd PD6 11 oJ o 9 gnd  + 10 o-----o +24V
'-------------------------------------------------------------------------------
'mit J=1 Ampelmode/Huser:
'
'2 separate Ampelkreuzungen
'2 phasenverschobene Neonreklamen fr Hotel/Apotheke _------__------_
'                                                    __------__------
'1 schneller Blinker fr Baustelle 1,4s+0,7s
'1 Zufallsgenerator fr Schweisslicht S (blau/weiss) (invers fr Feuer (rot/gelb))
'
'die Muster fr die Takte sind in den Data-Zeilen abgelegt
'die selben Muster und das Timing kann fr Huser verwendet werden
'
'je eine Ampel kann fr je ein Haus genutzt werden -> 4 Huser
'Axg=obere Etage, Axy=Flurlicht, Axr=untere Etage
'
'dank ULN2803 knnen je nach Farbe 4-8 LED in Reihe (an 24V=) betrieben werden
'1k2 begrenzt den Kurzschlussstrom auf 20mA (ggf.erhhen)
'-------------------------------------------------------------------------------
'mit J=0 Signalmode:
'
'4 Vor- und Hauptsignale im Bahnhofsbereich
'vereinfachte Darstellung = 2-wertig
'
'Mit dem verriegeln wird bei parallelen Gleisen sichergestellt,das nur ein Gleis grn erhlt
'
'parallel zu den Tasten kann ein Steuerbaustein mit Wischkontakten geschaltet werden
'ein Steuerbaustein mit Schaltkontakten speichert und kann die Signale direkt steuern
'
'      Vorsignal (VS)                 Hauptsignal (HS)
'      -----------------------------  -----------------------------------
'Rot:  gelb gelb = rot erwarten       rot rot (wei=Sperrsignal) anhalten
'Grn: ge ge gn gn = langsam fahren   ge ge gn gn = langsam ausfahren wg.Weichen
'      gelb -> GND leuchtet dauernd
'
'auf der linken Seite wird der ULN durch Tasten erzetzt
'-------------------------------------------------------------
$regfile = "attiny2313.dat"
$crystal = 1000000
'keine Fuse gendert
'Lockbits FF
'Fusebits 64           devide clock by 8 enabled = 0 -> 1MHz
'Fusebits high DF
'Fusebits Extended FF
'-------------------------------------------------------------
Ddra = 0                                                    'Eingnge
Ddrb = 255                                                  'Ausgnge
Ddrd = 0                                                    'Eingnge

Portd.6 = 1                                                 'pullup J
J Alias Pind.6                                              'J=Programmbrcke

T1g Alias Pind.5 : T1r Alias Pind.4 :                       'Tasten
T2g Alias Pind.3 : T2r Alias Pind.2
T3g Alias Pina.0 : T3r Alias Pina.1 :
T4g Alias Pind.1 : T4r Alias Pind.0

S1g Alias Portb.0 : S1r Alias Portb.1 :                     'Signale
S2g Alias Portb.2 : S2r Alias Portb.3
S3g Alias Portb.4 : S3r Alias Portb.5 :
S4g Alias Portb.6 : S4r Alias Portb.7

S1r = 1 : S2r = 1 : S3r = 1 : S4r = 1                       'alle Signale rot

Config Timer0 = Timer , Prescale = 64                       '64*256*1us =16384us
On Ovf0 T0interrupt : Enable Timer0
Start Timer0 : Enable Interrupts

Dim Delayms As Word                                         'besser als Wait
Dim I As Byte                                               'Index fr Dta
Dim Muster As Byte , Muster1 As Byte , Muster2 As Byte      'Muster
Dim Blitz As Byte                                           'Schweisslicht
'-------------------------------------------------------------
Do
Portd.6 = 1                                                 'pullup J
If J = 1 Then Goto Ampelmode
Signalmode:
   Ddra = 0                                                 'Eingnge
   Ddrd = 0                                                 'Eingnge
   Porta = 3                                                'pullup
   Portd = 127                                              'pullup
   If T1g = 0 Then : S1r = 0 : S2r = 1 : S3r = 1 : S4r = 1 : End If       'grne Tasten
   If T2g = 0 Then : S1r = 1 : S2r = 0 : S3r = 1 : S4r = 1 : End If       'rote Signale
   If T3g = 0 Then : S1r = 1 : S2r = 1 : S3r = 0 : S4r = 1 : End If       'Verriegelt
   If T4g = 0 Then : S1r = 1 : S2r = 1 : S3r = 1 : S4r = 0 : End If
   If T1r = 0 Then S1r = 1                                  'rote Tasten
   If T2r = 0 Then S2r = 1                                  'rote Signale
   If T3r = 0 Then S3r = 1                                  'haben Vorrang
   If T4r = 0 Then S4r = 1
   If S1r = 0 Then S1g = 1 Else S1g = 0                     'Aufrumen =
   If S2r = 0 Then S2g = 1 Else S2g = 0                     'grne Signale ergnzen
   If S3r = 0 Then S3g = 1 Else S3g = 0
   If S4r = 0 Then S4g = 1 Else S4g = 0
   If Pind = 63 And Pina = 3 Then Goto Ampelmode_ende Else Waitms 150       'gegen prellen
Signalmode_ende:
Goto Ampelmode_ende
'-----------------------------------------------------------
Ampelmode:
   Ddra = 3                                                 'Ausgnge
   Ddrd = 63                                                'nur J=Eingang
   Restore Dta0
   For I = 0 To 31
      Read Muster
      Read Muster1
      Read Muster2
      Porta = Muster
      Portb = Muster2
      Portd = Muster1
      Delayms = 128                                         '2s-Takte = 64s gesamt
      While Delayms > 0
         If Delayms < 84 Then S4g = 1 Else S4g = 0          'Blink 1,4s:0,7s
      Wend
   Next
Ampelmode_ende:
Loop
'=============================================================
T0interrupt:                                                'alle 16,384ms
   If Delayms > 0 Then Decr Delayms
   If J = 0 Then Goto T0interrupt_ende                      'Signalmode ?
      Blitz = Rnd(30)                                       '2^n-2
      If Blitz = 0 Then S4r = 1 Else S4r = 0                'bl/ws Blitz
'      If Blitz = 0 Then S4r = 0 Else S4r = 1                'rt/ge Feuer
T0interrupt_ende:
Return
'------------------------------------------------------------
Dta0:
'     PortA        PortD        PortB
'             +--<----------+
'             |+->--------+ |        A2 A1
'             rg      JNNryyg     SBrygryg
Data &B00000011 , &B01110000 , &B00100100                   '  gn rt rt rt
Data &B00000011 , &B01110000 , &B00100110                   '---------->ry
Data &B00000011 , &B01110000 , &B00100001                   '---------->gn
Data &B00000011 , &B01100000 , &B00100001                   '  gn rt rt gn
Data &B00000011 , &B01000000 , &B00100001                   '  gn rt rt gn
Data &B00000011 , &B01010000 , &B00100001                   '  gn rt rt gn
Data &B00000011 , &B01110000 , &B00100001                   '  gn rt rt gn
Data &B00000010 , &B01110100 , &B00100001                   '->ge
Data &B00000010 , &B01111000 , &B00100001                   '->rt
Data &B00000010 , &B01111010 , &B00100001                   '---->ry
Data &B00000000 , &B01111001 , &B00100001                   '---->gn
Data &B00000000 , &B01101001 , &B00100001                   '  rt gn rt gn
Data &B00000000 , &B01001001 , &B00100001                   '  rt gn rt gn
Data &B00000000 , &B01011001 , &B00100001                   '  rt gn rt gn
Data &B00000000 , &B01111001 , &B00100001                   '  rt gn rt gn
Data &B00000000 , &B01111001 , &B00100010                   '---------->ge
Data &B00000000 , &B01111001 , &B00100100                   '---------->rt          '
Data &B00000000 , &B01111001 , &B00110100                   '------->ry
Data &B00000000 , &B01111001 , &B00001100                   '------->gn
Data &B00000000 , &B01101001 , &B00001100                   '  rt gn gn rt
Data &B00000000 , &B01001001 , &B00001100                   '  rt gn gn rt
Data &B00000000 , &B01011001 , &B00001100                   '  rt gn gn rt
Data &B00000000 , &B01111001 , &B00001100                   '  rt gn gn rt
Data &B00000000 , &B01111010 , &B00001100                   '---->ge
Data &B00000010 , &B01111000 , &B00001100                   '---->rt
Data &B00000010 , &B01111100 , &B00001100                   '->ry
Data &B00000011 , &B01110000 , &B00001100                   '->gn
Data &B00000011 , &B01100000 , &B00001100                   '  gn rt gn rt
Data &B00000011 , &B01000000 , &B00001100                   '  gn rt gn rt
Data &B00000011 , &B01010000 , &B00001100                   '  gn rt gn rt
Data &B00000011 , &B01110000 , &B00001100                   '  gn rt gn rt
Data &B00000011 , &B01110000 , &B00010100                   '------->ge
'             rg      JNNryyg     SBrygryg
'             |+->--------+|
'             +--<---------+
'                        A4 A3       A2 A1
Data 0                                                      'ende